"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _vue = require("vue");

var antvRef = {
  beforeMount: function bind(el, binding, vnode) {
    (0, _vue.nextTick)(function () {
      binding.value(el, vnode.key);
    });
    binding.value(el, vnode.key);
  },
  updated: function update(el, binding, vnode, oldVnode) {
    if (oldVnode && oldVnode.directives) {
      var oldBinding = oldVnode.directives.find(function (directive) {
        return directive === antvRef;
      });

      if (oldBinding && oldBinding.value !== binding.value) {
        oldBinding && oldBinding.value(null, oldVnode.key);
        binding.value(el, vnode.key);
        return;
      }
    } // Should not have this situation


    if (vnode.el !== oldVnode.el) {
      binding.value(el, vnode.key);
    }
  },
  unmounted: function unbind(el, binding, vnode) {
    binding.value(null, vnode.key);
  }
};
var _default = antvRef;
exports.default = _default;