"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _vue = _interopRequireWildcard(require("vue"));

var _vueTypes = _interopRequireDefault(require("../_util/vue-types"));

var _empty = _interopRequireDefault(require("../empty"));

var _ = require("./");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var RenderEmpty = {
  props: {
    componentName: _vueTypes.default.string
  },
  setup: function setup(props) {
    var configProvider = (0, _vue.inject)('configProvider', _.ConfigConsumerProps);

    function renderHtml(componentName) {
      var getPrefixCls = configProvider.getPrefixCls;
      var prefix = getPrefixCls('empty');

      switch (componentName) {
        case 'Table':
        case 'List':
          return _vue.createVNode(_empty.default, {
            "image": _vue.createVNode(_empty.default.PRESENTED_IMAGE_SIMPLE, null, null)
          }, null);

        case 'Select':
        case 'TreeSelect':
        case 'Cascader':
        case 'Transfer':
        case 'Mentions':
          return _vue.createVNode(_empty.default, {
            "image": _vue.createVNode(_empty.default.PRESENTED_IMAGE_SIMPLE, null, null),
            "class": "".concat(prefix, "-small")
          }, null);

        default:
          return _vue.createVNode(_empty.default, null, null);
      }
    }

    return function () {
      return renderHtml(props.componentName);
    };
  }
};

function renderEmpty(componentName) {
  return _vue.createVNode(RenderEmpty, {
    "componentName": componentName
  }, null);
}

var _default = renderEmpty;
exports.default = _default;